<script lang="ts" setup>
import { ref } from 'vue';
import { Close } from 'slippers-ui/icons';
import type { SearchData } from '@/types/navigation';
// Props
const props = defineProps<SearchData>();

// Emit events
const emit = defineEmits(['close']);
const router = useRouter();

// Reactive data
const searchResults = ref(null);

// Methods
const close = () => {
  emit('close');
};

const onSearch = (text: string) => {
  router.push({
    path: '/search',
    query: { searchText: text },
  });
  close();
};
</script>

<template>
  <section class="be-nav-search">
    <SlpContainer class="be-nav-search__container">
      <SlpRow class="be-nav-search__row">
        <SlpColumn :cols="10">
          <template v-if="!searchResults">
            <div class="be-nav-search__close">
              <SlpButton variant="ghost" @click="close">
                <SlpTypography variant="body3" class="be-nav-search__close--text"> {{ props.close }} </SlpTypography>
                <SlpIcon :icon="Close" size="md" class="slp-mr-16" />
              </SlpButton>
            </div>
            <NavigationSearchContent v-bind="props" @search="onSearch" />
          </template>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.be-nav-search {
  position: fixed;
  top: 84px;
  right: 0;
  bottom: 0;
  left: 0;
  background-color: $color-surface-50;
  overflow-y: scroll;

  @media (max-width: $breakpoint-lg) {
    top: 0;
    overflow-x: hidden;
  }

  &__container {
    height: 100%;

    @media (max-width: $breakpoint-lg) {
      padding: 0 !important;
    }
  }

  &__row {
    height: 100%;
    flex-wrap: nowrap !important;
    justify-content: center;
    &:focus-visible {
      outline: none;
    }
  }

  &__close {
    display: flex;
    justify-content: flex-end;
    margin-top: $spacing-16;

    &--text {
      color: $color-text-300 !important;
    }
  }
}
</style>
